#define _USE_MATH_DEFINES
 
#include "wSolutionInterp.h"
#include <iostream>
#include <unordered_set>
#include <fstream>
#include <iomanip>

using namespace dart;

SolutionInterp::SolutionInterp(unsigned int _meshFactor)
{
  meshFactor = _meshFactor;
  CoarseMeshInit = false;
  
} // end SolutionInterp


SolutionInterp::~SolutionInterp()
{   
  std::cout << "~SolutionInterp()\n";
} // end ~SolutionInterp

void SolutionInterp::InputCoarseMesh(std::vector<double> _CoarseLocMesh, std::vector<double> _CoarseGlobMesh)
{
  CoarseLocMesh = _CoarseLocMesh;
  CoarseGlobMesh = _CoarseGlobMesh;
  CoarseMeshInit = true;
}
void SolutionInterp::InputFineMesh(std::vector<double> _fineLocMesh, std::vector<double> _fineGlobMesh)
{
  FineLocMesh=_fineLocMesh;
  FineGlobMesh=_fineGlobMesh;
}

std::vector<double> SolutionInterp::InterpolateToFineMesh(std::vector<double> cVector)
{
  if (meshFactor<=1)
  {
    std::cout << "Can not create finer mesh while meshFactor is " << meshFactor << std::endl;
    return cVector;
  }
  else
  {
    std::vector<double> fVector;
    double dv;
    for (size_t cPoint=0; cPoint<cVector.size()-1; ++cPoint)
    {
      dv = cVector[cPoint+1] - cVector[cPoint];

      for (size_t fPoint=0; fPoint<meshFactor; ++fPoint)
      {
        fVector.push_back(cVector[cPoint] + fPoint * dv / meshFactor);
      }
    }
    std::cout << cVector.back() << std::endl;
    fVector.push_back(cVector.back());
    return fVector;
  }
}

std::vector<double> SolutionInterp::CreateFineMesh(std::vector<double> cMesh)
{
  if (meshFactor<1)
  {
    std::cout << "SolutionInterp::CreateFineMesh: Mesh factor should be > 1." << std::endl;
    /*std::stringstream err;
    err << "SolutionInterp::CreateFineMesh: Mesh factor should be > 1. Value: " << meshFactor << "\n";
    throw std::runtime_error(err.str());*/
  }

  else
  {

    double dx;
    
    /* Local markers */

    std::vector<double> fMesh;
    for (size_t iPoint=0; iPoint<cMesh.size()-1; ++iPoint)
    {
      dx = cMesh[iPoint + 1] - cMesh[iPoint];

      for(size_t iRefinedPoint = 0; iRefinedPoint < meshFactor; ++iRefinedPoint)
      {
        fMesh.push_back(cMesh[iPoint] + iRefinedPoint * dx/meshFactor);
      }
    }
    fMesh.push_back(cMesh.back());
    return fMesh;
  }
}

void SolutionInterp::ResetmeshFactor(unsigned int newmeshFactor)
{
  meshFactor = newmeshFactor;
}