#ifndef WSolutionInterp_H
#define WSolutionInterp_H

#include "dart.h"
#include "wBLRegion.h"
#include <vector>
#include <string>

namespace dart
{

class DART_API SolutionInterp
{
private:
  unsigned int meshFactor;
public:
  std::vector<double> FineLocMesh;
  std::vector<double> FineGlobMesh;
  std::vector<double> CoarseLocMesh;
  std::vector<double> CoarseGlobMesh;
  bool CoarseMeshInit;
public:
  SolutionInterp(unsigned int _meshFactor=1);
  ~SolutionInterp();

  void InputFineMesh(std::vector<double> _fineLocMesh, std::vector<double> _fineGlobMesh);
  std::vector<double> CreateFineMesh(std::vector<double> cMesh);
  void ResetmeshFactor(unsigned int newmeshFactor);
  std::vector<double> InterpolateToFineMesh(std::vector<double> cVector);
  void InputCoarseMesh(std::vector<double> _CoarseLocMesh, std::vector<double> _CoarseGlobMesh);
};
} // namespace dart
#endif //WSolutionInterp_H